<template>
    <q-layout>
        <q-drawer
            v-model="leftDrawerOpen"
            show-if-above
            :bordered="false"
            :mini="miniState"
            :mini-width="120"
            :width="120"
            :breakpoint="500"
            :no-swipe-open="true"
            class="left-drawer q-pa-md"
        >
            <q-scroll-area class="fit" :visible="visible">
                <!-- BUSINESS EXPAND BAR -->
                <div class="business-expand-bar text-center">
                    <q-toggle
                        v-model="expanded"
                        label="Collapse"
                        class="q-mb-sm q-pt-sm"
                        v-if="expanded"
                    />
                    <q-expansion-item
                        class="row justify-center"
                        v-model="expanded"
                    >
                        <q-list
                            padding
                            class="q-pb-none q-pa-none"
                            v-if="businessState.businesses"
                        >
                            <q-item
                                v-for="business in businessState.businesses"
                                :key="business.id"
                                clickable
                                v-ripple
                                @click="selectBusiness(business.id, 'click')"
                            >
                                <div class="business-notification"></div>

                                <q-img
                                    class="account-logo-img"
                                    v-if="business.imageUrl"
                                    :src="business.imageUrl"
                                    width="55px"
                                    height="55px"
                                    img-class="rounded-img"
                                    :class="
                                        businessState.businessID == business.id
                                            ? 'q-mb-sm active items-center justify-center'
                                            : 'q-mb-sm items-center justify-center'
                                    "
                                />
                                <q-img
                                    v-else
                                    src="~/assets/images/business-default-icon.png"
                                    width="40px"
                                    height="36px"
                                    fit="contain"
                                    :alt="business.name"
                                    :title="business.name"
                                    :class="
                                        businessState.businessID == business.id
                                            ? 'q-mb-sm active items-center justify-center'
                                            : 'q-mb-sm items-center justify-center'
                                    "
                                />
                            </q-item>
                        </q-list>
                    </q-expansion-item>
                </div>

                <!-- BUSINESS SHRINK BAR -->
                <div
                    class="business-shrink-bar text-center q-pa-xs"
                    v-if="!expanded"
                    @click="expanded = true"
                >
                    <div class="row">
                        <div
                            class="col-6 q-my-xs"
                            v-for="business in businessState.businesses"
                            :key="business.id"
                        >
                            <q-img
                                v-if="business.imageUrl"
                                :src="business.imageUrl"
                                fit="contain"
                                class="q-item items-center"
                                :alt="business.name"
                                :title="business.name"
                                width="80%"
                            />
                            <q-img
                                v-else
                                src="~/assets/images/business-default-icon.png"
                                fit="contain"
                                class="q-item items-center"
                                width="80%"
                                :alt="business.name"
                                :title="business.name"
                            />
                        </div>
                    </div>
                </div>

                <q-separator inset class="q-my-md separator" />

                <!-- MENU BAR -->
                <div class="menu-bar">
                    <q-list padding class="q-pa-none">
                        <q-item
                            @click="pagePressed('home')"
                            clickable
                            v-ripple
                            :class="
                                menuState.home
                                    ? 'active q-mb-md items-center justify-center'
                                    : 'q-mb-md items-center justify-center'
                            "
                        >
                            <div class="business-notification"></div>
                            <q-img
                                v-if="menuState.home"
                                src="~assets/images/home-black.png"
                                fit="contain"
                                width="26px"
                                height="24px"
                            />
                            <q-img
                                v-else
                                src="~assets/images/home-white.png"
                                fit="contain"
                                width="26px"
                                height="24px"
                            />
                        </q-item>
                        <q-item
                            @click="pagePressed('helpdesk')"
                            clickable
                            v-ripple
                            :class="
                                menuState.helpdesk
                                    ? 'active q-mb-md items-center justify-center'
                                    : 'q-mb-md items-center justify-center'
                            "
                            v-if="permission.conversation?.list"
                        >
                            <div class="business-notification"></div>
                            <q-img
                                v-if="menuState.helpdesk"
                                src="~assets/images/helpdesk-black.png"
                                fit="contain"
                                width="24px"
                                height="26px"
                            />
                            <q-img
                                v-else
                                src="~assets/images/helpdesk-white.png"
                                fit="contain"
                                width="24px"
                                height="26px"
                            />
                        </q-item>

                        <!--  <q-item
                            @click="pagePressed('attendance')"
                            clickable
                            v-ripple
                            :class="
                                menuState.attendance
                                    ? 'active q-mb-md items-center justify-center'
                                    : 'q-mb-md items-center justify-center'
                            "
                        >
                            <q-img
                                v-if="menuState.attendance"
                                src="~assets/images/attendance-black.png"
                                fit="contain"
                                width="25px"
                                height="25px"
                            />
                            <q-img
                                v-else
                                src="~assets/images/attendance-white.png"
                                fit="contain"
                                width="25px"
                                height="25px"
                            />
                        </q-item> -->

                        <q-item
                            @click="pagePressed('preference')"
                            clickable
                            v-ripple
                            :class="
                                menuState.preference
                                    ? 'active q-mb-md items-center justify-center'
                                    : 'q-mb-md items-center justify-center'
                            "
                        >
                            <q-img
                                v-if="menuState.preference"
                                src="~assets/images/preference-black.png"
                                fit="contain"
                                width="25px"
                                height="25px"
                            />
                            <q-img
                                v-else
                                src="~assets/images/preference-white.png"
                                fit="contain"
                                width="25px"
                                height="25px"
                            />
                        </q-item>

                        <q-item
                            @click="pagePressed('logout')"
                            clickable
                            v-ripple
                            class="
                                q-mb-md
                                items-center
                                text-white
                                justify-center
                                text-center
                            "
                        >
                            <h5><span class="material-icons">logout</span></h5>
                        </q-item>
                    </q-list>
                </div>
            </q-scroll-area>
        </q-drawer>

        <q-drawer
            v-model="menuDrawer"
            v-if="$q.platform.is.mobile"
            :no-swipe-open="true"
            show-if-above
            :bordered="false"
            :mini="miniState"
            :mini-width="120"
            :width="120"
            :breakpoint="500"
            class="left-drawer q-pa-md"
        >
            <q-btn
                class="close-left-drawer"
                flat
                text-color="white"
                size="md"
                icon="clear"
                @click="closeMenu(false)"
            />
            <q-scroll-area class="fit" :visible="visible">
                <!-- BUSINESS EXPAND BAR -->
                <div class="business-expand-bar text-center">
                    <q-toggle
                        v-model="expanded"
                        label="Collapse"
                        class="q-mb-sm q-pt-sm"
                        v-if="expanded"
                    />
                    <q-expansion-item
                        class="row justify-center"
                        v-model="expanded"
                    >
                        <q-list
                            padding
                            class="q-pb-none q-pa-none"
                            v-if="businessState.businesses"
                        >
                            <q-item
                                v-for="business in businessState.businesses"
                                :key="business.id"
                                clickable
                                v-ripple
                                :class="
                                    businessState.businessID == business.id
                                        ? 'q-mb-sm active items-center justify-center'
                                        : 'q-mb-sm items-center justify-center'
                                "
                                @click="selectBusiness(business.id, 'click')"
                            >
                                <div class="business-notification"></div>
                                <q-img
                                    v-if="business.imageUrl"
                                    :src="business.imageUrl"
                                    width="40px"
                                    height="36px"
                                    fit="contain"
                                    :alt="business.name"
                                    :title="business.name"
                                />
                                <q-img
                                    v-else
                                    src="~/assets/images/business-default-icon.png"
                                    width="40px"
                                    height="36px"
                                    fit="contain"
                                    :alt="business.name"
                                    :title="business.name"
                                />
                            </q-item>
                        </q-list>
                    </q-expansion-item>
                </div>

                <!-- BUSINESS SHRINK BAR -->
                <div
                    class="business-shrink-bar text-center q-pa-xs"
                    v-if="!expanded"
                    @click="expanded = true"
                >
                    <div class="row">
                        <div
                            class="col-6 q-my-xs"
                            v-for="business in businessState.businesses"
                            :key="business.id"
                        >
                            <q-img
                                v-if="business.imageUrl"
                                :src="business.imageUrl"
                                fit="contain"
                                class="q-item items-center"
                                :alt="business.name"
                                :title="business.name"
                                width="80%"
                            />
                            <q-img
                                v-else
                                src="~/assets/images/business-default-icon.png"
                                fit="contain"
                                class="q-item items-center"
                                width="80%"
                                :alt="business.name"
                                :title="business.name"
                            />
                        </div>
                    </div>
                </div>

                <q-separator inset class="q-my-md separator" />

                <!-- MENU BAR -->
                <div class="menu-bar">
                    <q-list padding class="q-pa-none">
                        <q-item
                            @click="pagePressed('home')"
                            clickable
                            v-ripple
                            :class="
                                menuState.home
                                    ? 'active q-mb-md items-center justify-center'
                                    : 'q-mb-md items-center justify-center'
                            "
                        >
                            <div class="business-notification"></div>
                            <q-img
                                v-if="menuState.home"
                                src="~assets/images/home-black.png"
                                fit="contain"
                                width="26px"
                                height="24px"
                            />
                            <q-img
                                v-else
                                src="~assets/images/home-white.png"
                                fit="contain"
                                width="26px"
                                height="24px"
                            />
                        </q-item>
                        <q-item
                            @click="pagePressed('helpdesk')"
                            clickable
                            v-ripple
                            :class="
                                menuState.helpdesk
                                    ? 'active q-mb-md items-center justify-center'
                                    : 'q-mb-md items-center justify-center'
                            "
                            v-if="permission.conversation?.list"
                        >
                            <div class="business-notification"></div>
                            <q-img
                                v-if="menuState.helpdesk"
                                src="~assets/images/helpdesk-black.png"
                                fit="contain"
                                width="24px"
                                height="26px"
                            />
                            <q-img
                                v-else
                                src="~assets/images/helpdesk-white.png"
                                fit="contain"
                                width="24px"
                                height="26px"
                            />
                        </q-item>

                        <!--  <q-item
                            @click="pagePressed('attendance')"
                            clickable
                            v-ripple
                            :class="
                                menuState.attendance
                                    ? 'active q-mb-md items-center justify-center'
                                    : 'q-mb-md items-center justify-center'
                            "
                        >
                            <q-img
                                v-if="menuState.attendance"
                                src="~assets/images/attendance-black.png"
                                fit="contain"
                                width="25px"
                                height="25px"
                            />
                            <q-img
                                v-else
                                src="~assets/images/attendance-white.png"
                                fit="contain"
                                width="25px"
                                height="25px"
                            />
                        </q-item> -->

                        <q-item
                            @click="pagePressed('preference')"
                            clickable
                            v-ripple
                            :class="
                                menuState.preference
                                    ? 'active q-mb-md items-center justify-center'
                                    : 'q-mb-md items-center justify-center'
                            "
                        >
                            <q-img
                                v-if="menuState.preference"
                                src="~assets/images/preference-black.png"
                                fit="contain"
                                width="25px"
                                height="25px"
                            />
                            <q-img
                                v-else
                                src="~assets/images/preference-white.png"
                                fit="contain"
                                width="25px"
                                height="25px"
                            />
                        </q-item>

                        <q-item
                            @click="pagePressed('logout')"
                            clickable
                            v-ripple
                            class="
                                q-mb-md
                                items-center
                                text-white
                                justify-center
                                text-center
                            "
                        >
                            <h5><span class="material-icons">logout</span></h5>
                        </q-item>
                    </q-list>
                </div>
            </q-scroll-area>
        </q-drawer>

        <!-- Setting Drawer -->
        <div class="settingDrawer">
            <setting-drawer />
        </div>

        <!-- Ongoing Drawer -->
        <div class="ongoingDrawer">
            <ongoing-drawer />
        </div>

        <!-- Note Drawer -->
        <div class="noteDrawer">
            <note-drawer />
        </div>

        <q-page-container>
            <router-view />
        </q-page-container>
    </q-layout>
</template>

<script lang="ts">
/* eslint-disable @typescript-eslint/no-floating-promises */
import { useRouter } from 'vue-router';
import { useStore } from 'src/store';
import { defineComponent, ref, onMounted, watch, computed } from 'vue';
import { mapGetters } from 'vuex';
import io from 'socket.io-client';
import { SocketMessageResponse } from 'src/services/responses/socket/SocketMessageResponse';
import { keyBy } from 'lodash';
import { debounce } from 'lodash';
import { useQuasar } from 'quasar';
import NoteDrawer from '../components/drawer/NoteDrawer.vue';
import OngoingDrawer from '../components/drawer/OngoingDrawer.vue';
import SettingDrawer from '../components/drawer/SettingDrawer.vue';
import { ConversationStatus } from 'src/services/enums/ConversationStatus';

export default defineComponent({
    name: 'MainLayout',
    components: {
        NoteDrawer,
        OngoingDrawer,
        SettingDrawer
    },
    computed: {
        ...mapGetters({
            selectedBusinessID: 'business/getBusinessID',
            permission: 'role/getPermissions',
            menuDrawer: 'menu/getMenuDrawer'
        })
    },
    setup() {
        const $q = useQuasar();

        // store
        const store = useStore();
        const menuState = store.state.menu;
        const businessState = store.state.business;
        const user = store.state.user.user;

        const selectedBranch = computed(() => {
            return store.state.branch.branch;
        });

        const businessID = computed(() => {
            return store.state.business.businessID;
        });

        // init
        store.dispatch('app/init');

        // socket
        let socket: any;
        // router
        const router = useRouter();

        // data
        const leftDrawerOpen = ref(false);
        const miniState = ref(true);
        const expanded = ref(true);
        const visible = ref(false);

        // methods
        const pagePressed = (page: string) => {
            if (page == 'logout') {
                store.dispatch('user/logout').then(() => {
                    socket.disconnect();
                    router.push('/');
                    store.dispatch('menu/setMenuDrawer', false);
                });
            } else {
                store.dispatch('conversation/clearSelectedConversationID');
                store.dispatch('menu/setPage', page);
                router.push('/' + page);
                store.dispatch('menu/setMenuDrawer', false);
                store.dispatch('menu/setNoteDrawer', false);
            }
        };

        const selectBusiness = debounce((businessID: string, type: any) => {
            store.dispatch('business/setBusinessID', businessID);
            store.dispatch('business/setBusinessEndPoint');
            store.dispatch('branch/setBranch', '');

            // set role permission
            const findBusinessIndex = store.state.business.businesses.findIndex(
                (element: any) => element.id == businessID
            );
            if (findBusinessIndex != -1) {
                // business owner
                if (
                    store.state.business.businesses[findBusinessIndex]?.member
                        .isOwner
                ) {
                    store.dispatch('role/getList', null, { root: true });
                } else {
                    // get role if authorized members
                    if (store.state.role.permissions.role?.list) {
                        store
                            .dispatch('role/getList', null, { root: true })
                            .then(() => {
                                store.commit(
                                    'role/setAgentRole',
                                    store.state.business.businesses[
                                        findBusinessIndex
                                    ].member.role
                                );
                            });
                    } else {
                        store.commit(
                            'role/setAgentRole',
                            store.state.business.businesses[findBusinessIndex]
                                .member.role
                        );
                    }
                }
            }

            // get joined conversations (only owner & authorized members)
            if (
                store.state.business.businesses[findBusinessIndex]?.member
                    .isOwner
            ) {
                // get conversation if authorized members
                if (store.state.role.permissions.conversation?.list) {
                    store.dispatch('conversation/getJoinedConversations', {
                        businessID: businessID,
                        agentID: user?.id,
                        status: 1
                    });
                }

                store.dispatch('branch/getBranches');
            } else {
                // get branch if authorized members)
                if (store.state.role.permissions.branch?.list) {
                    store.dispatch('branch/getBranches');
                }
            }

            if (type == 'click') {
                router.push('/helpdesk');
                store.dispatch('message/clearAllMessagesHistory');
                store.dispatch('conversation/closeConversation');
                store.dispatch('chat/unselectConversation');
                store.dispatch('message/reset');
                store.dispatch('menu/clearPage');
                store.dispatch('menu/setPage', 'helpdesk');
            }

            store.dispatch('menu/setMenuDrawer', false);
            connectBusinessSocket();
        }, 500);

        const connectBusinessSocket = () => {
            setTimeout(() => {
                // disconnect & reconnect socket
                if (socket) {
                    socket.disconnect();
                }

                socket = io(
                    store.state.business.businessEndPoint ??
                        store.state.business.businesses[0].service.endpoint,
                    {
                        transports: ['websocket']
                    }
                );

                socket.on('connect', function () {
                    console.log(
                        'Business >>',
                        'Socket business connection successful'
                    );

                    if (store.state.auth.token) {
                        socket.emit(
                            'authenticate',
                            'business/' + store.state.auth.token
                        );
                    }
                });

                socket.on('disconnect', function () {
                    console.log('Business >>', 'Socket business disconnected');
                });

                socket.io.on('reconnect', () => {
                    console.log('Business >>', 'Socket business reconnected');
                });

                socket.io.on('reconnection_attempt', () => {
                    console.log(
                        'Business >>',
                        'Socket business reconnecting...'
                    );
                });

                socket.on('connect_error', () => {
                    setTimeout(() => {
                        socket.connect();
                    }, 1000);
                });

                socket.on('message', (data: string) => {
                    const payload: SocketMessageResponse = JSON.parse(data);
                    const payload2: any = JSON.parse(data);
                    console.log(payload2);
                    if (payload2.conversation?.status == 0) {
                        store.dispatch(
                            'conversation/setSocketSignal',
                            payload2
                        );
                        store.dispatch('menu/setNotify', true);

                        autoAssign(payload2.conversation.id);
                    }

                    //  End Conversation
                    if (payload2?.conversation?.status == 2) {
                        if (
                            payload2.conversation.id ==
                            store.state.conversation.selectedConversationID
                        ) {
                            store.dispatch('conversation/closeConversation');
                            store.dispatch('chat/unselectConversation');
                            store.dispatch('message/reset');
                            store.dispatch(
                                'conversation/removeConvoFromList',
                                payload2.conversation.id
                            );
                            store.dispatch(
                                'conversation/clearSelectedConversation'
                            );
                            store.dispatch(
                                'conversation/clearSelectedConversationID'
                            );
                            router.push('/helpdesk');
                        } else {
                            // client end chat from mobile
                            store.dispatch(
                                'conversation/updateConversationTransferList',
                                payload2.conversation.id
                            );

                            // update all chat table status
                            store.dispatch(
                                'conversation/updateConversationListStatus',
                                payload2.conversation.id
                            );
                        }
                    }

                    const room = payload2.room.substr(
                        0,
                        payload2.room.indexOf('/')
                    );

                    // Action for selected user (user/userId)
                    if (room == 'user') {
                        userAction(payload2);
                    }

                    /*  console.log(room == 'pool' && continues, 99) */
                    // Action for everyone within this business (pool/businessId)
                    if (room == 'pool' /*  && continues == '' */) {
                        poolAction(payload2);
                    }

                    if (room == 'conversation') {
                        if (store.state.conversation.changeIssuesType == true) {
                            // alert('Changing....')
                        } else {
                            if (payload2?.message?.type == 0) {
                                store.dispatch(
                                    'conversation/removeConvoFromList',
                                    payload2?.message?.conversationId
                                );
                                if (payload2?.conversation?.status == 2) {
                                    store.dispatch(
                                        'conversation/changeStatusConvo',
                                        payload2?.message
                                    );
                                }
                            }
                        }
                    }
                    // Message
                    if (payload2?.message?.type) {
                        let res = false;
                        store.state.conversation.conversationsList.find(
                            (element) => {
                                if (
                                    payload2.message.conversationId ==
                                    element.id
                                ) {
                                    res = true;
                                }
                            }
                        );
                        if (res) {
                            store.dispatch(
                                'message/newMessage',
                                payload2.message
                            );

                            // Only show latest message when chat is active
                            if (
                                store.state.conversation
                                    .selectedConversationID != '' &&
                                store.state.conversation
                                    .selectedConversationID != '0'
                            ) {
                                store.dispatch(
                                    'message/putLatestMessage',
                                    payload2.message
                                );
                            }

                            // Only show when the message is not send by you
                            if (
                                store.state.user.user?.id !=
                                payload2.message.user.id
                            ) {
                                store.dispatch(
                                    'notification/setList',
                                    payload2.message
                                );
                            }

                            store.dispatch(
                                'conversation/updateTime',
                                payload2.message
                            );

                            checkMessageLength();
                        }
                    }

                    // Handle typing
                    if (payload.type == 'system') {
                        // Handle new message
                        if (
                            payload.body?.message &&
                            payload.body?.message?.createdAt
                        ) {
                            store.dispatch(
                                'message/putLatestMessage',
                                payload.body?.message
                            );
                            store.dispatch(
                                'conversation/putLatestMessage',
                                payload.body?.message
                            );
                        }
                        // Handle new conversation
                        if (payload.body?.conversation) {
                            store.dispatch('conversation/update', {
                                ...payload.body?.conversation,
                                members: keyBy(
                                    payload.body?.conversation.members,
                                    'userId'
                                )
                            });
                        }
                    }
                });
            }, 1000);
        };

        const checkMessageLength = () => {
            store.dispatch(
                'message/checkMessageLength',
                store.state.chat.selectedConversation?.id
            );
        };

        const currentUser = store.state.user.user?.id;

        const userAction = (response: any) => {
            // Normal Transfer
            if (response?.room == 'user/' + currentUser) {
                if (response.transfer) {
                    const acceptTransferCondition1 =
                        response.transfer.type == 2;

                    // Accept Conversation
                    if (acceptTransferCondition1) {
                        console.log(
                            'Someone have normal transfer to u please response'
                        );
                        let resultFilter = {
                            id: response.transfer.id,
                            conversationId: response.transfer.conversation.id,
                            user: response.transfer.user,
                            agent: response.transfer.agent,
                            type: response.transfer.type,
                            status: response.transfer.status,
                            createdAt: response.transfer.createdAt
                        };
                        store.dispatch('notification/setList', response);
                        const transferCondition =
                            store.state.conversation.conversationsTransferList.findIndex(
                                (element: any) => {
                                    if (
                                        response.transfer.conversation.id ===
                                        element.conversationId
                                    ) {
                                        return true;
                                    }
                                }
                            );
                        if (transferCondition == -1) {
                            store.dispatch(
                                'conversation/pushTransferConversation',
                                resultFilter
                            );
                        }
                    }

                    // Request Conversation
                    if (response.transfer.type == 1) {
                        let resultFilter = {
                            id: response.transfer.id,
                            conversationId: response.transfer.conversationId,
                            user: response.transfer.user,
                            agent: response.transfer.agent,
                            type: response.transfer.type,
                            status: response.transfer.status,
                            createdAt: response.transfer.createdAt
                        };
                        store.dispatch('notification/setList', response);
                        const transferCondition =
                            store.state.conversation.conversationsTransferList.findIndex(
                                (element: any) => {
                                    if (
                                        response.transfer.conversationId ===
                                        element.conversationId
                                    ) {
                                        return true;
                                    }
                                }
                            );
                        if (transferCondition == -1) {
                            store.dispatch(
                                'conversation/pushTransferConversation',
                                resultFilter
                            );
                        }
                    }

                    if (
                        response.transfer.status == 1 &&
                        !response.transfer.type
                    ) {
                        store.dispatch(
                            'conversation/removeConvoFromList',
                            response.transfer.conversationId
                        );
                        store.dispatch(
                            'conversation/changeStatusConvo',
                            response.transfer
                        );
                        store.dispatch(
                            'conversation/clearSelectedConversationID'
                        );
                        store.dispatch('chat/unselectConversation');
                        store.dispatch('message/reset');
                        router.push('/helpdesk');
                    }

                    if (
                        response.transfer.status == 2 &&
                        !response.transfer.type
                    ) {
                        store.dispatch(
                            'conversation/changeStatusConvo',
                            response.transfer
                        );
                    }

                    // Cancel Conversation
                    if (
                        response.transfer.status == ConversationStatus.PENDING
                    ) {
                        // Remove from recipient request list
                        const index =
                            store.state.conversation.conversationsTransferList.indexOf(
                                (element: any) =>
                                    element.id == response.transfer.id
                            );

                        if (index != -1) {
                            store.state.conversation.conversationsTransferList.splice(
                                index,
                                1
                            );

                            store.commit(
                                'conversation/setConversationsTransferList',
                                store.state.conversation
                                    .conversationsTransferList
                            );
                        }
                    }
                }
            }
        };

        const poolAction = (response: any) => {
            // Related to conversation
            if (response.conversation) {
                const conversation = response.conversation;
                // Force Transfer
                // Compare new coming in conversation id with current state conversation list
                if (conversation.agent) {
                    getConversationsTransferList();

                    const forceTransferCondition1 =
                        conversation.agent.id == currentUser;
                    const forceTransferCondition2 =
                        !store.state.conversation.conversationsList.find(
                            (element) => {
                                conversation.id == element.id;
                            }
                        );
                    const forceTransferCondition3 =
                        store.state.conversation.conversationsTransferList.findIndex(
                            (element: any) => {
                                if (
                                    conversation.id === element.conversationId
                                ) {
                                    return true;
                                }
                            }
                        );
                    if (
                        forceTransferCondition1 &&
                        forceTransferCondition2 &&
                        forceTransferCondition3 == -1
                    ) {
                        console.log(
                            'Someone have force transfer conversation to you'
                        );
                        store.dispatch('notification/setList', response);
                        store.dispatch(
                            'conversation/changeStatusConvo',
                            response.conversation
                        );

                        // Notify the force transfer
                        const user = store.state.user.user;
                        /* const conversationLength =
                            store.state.conversation.conversationLength; */

                        store
                            .dispatch('conversation/getJoinedConversations', {
                                businessID: businessState.businessID,
                                agentID: user?.id,
                                status: 1
                            })
                            .then(() => {
                                store.dispatch(
                                    'issueType/setForceTransferNotification',
                                    conversation.id
                                );
                            });
                    } else if (conversation.agent.id != currentUser) {
                        store.dispatch(
                            'conversation/changeStatusConvo',
                            response.conversation
                        );
                    }
                }

                // end user end chat
                if (response.conversation.status == 2) {
                    // set assign success state
                    store.dispatch('conversation/setAssignSuccess', true);
                }

                // other agent have transfer the chat and pending response
                if (
                    response.conversation.transfer &&
                    response.conversation.transfer.status == 0
                ) {
                    store.dispatch(
                        'conversation/changeStatusConvo',
                        response.conversation
                    );
                }

                getConversationsTransferList();
            }
        };

        const getConversationsTransferList = () => {
            store.dispatch(
                'conversation/getConversationsTransferList',
                store.state.business.businessID
            );
        };

        const getJoinedConversationsList = () => {
            store.dispatch('conversation/getJoinedConversations', {
                businessID: store.state.business.businessID,
                agentID: store.state.user?.user?.id,
                status: 1
            });
        };

        const getBusiness = () => {
            store.dispatch('business/getBusinesses');
            setTimeout(() => {
                selectBusiness(businessID.value as string, 'restart');
            }, 300);
        };

        const getMembers = async () => {
            await store.dispatch('member/getList', {
                status: 1,
                branchIds: [store.state.branch.branch.id]
            });
        };

        const getPendingList = async () => {
            await store.dispatch('member/getList', {
                status: 0
            });
        };

        const closeMenu = (status: boolean) => {
            store.dispatch('menu/setMenuDrawer', status);
        };

        const autoAssign = async (conversationId: string) => {
            const result = store.state.business.settings.filter(
                (setting: any) => {
                    return (
                        setting.businessId == store.state.business.businessID
                    );
                }
            );

            const autoAssignFlag = result[0].autoAssignFlag;
            const maxActiveConversation = result[0].maxActiveConversation ?? 0;
            const countConversationList =
                store.state.conversation.conversationsList.length;

            if (
                autoAssignFlag == 1 &&
                countConversationList < maxActiveConversation
            ) {
                await store.dispatch('conversation/joinConversation', {
                    conversationId
                });
            }
        };

        // watch
        watch(selectedBranch, (currentValue) => {
            if (
                currentValue &&
                store.state.role.permissions.conversation?.list
            ) {
                getJoinedConversationsList();
                getMembers();
                getPendingList();
            }
        });

        // mounted
        onMounted(connectBusinessSocket);
        onMounted(getBusiness);
        onMounted(getMembers);
        // onMounted(getPendingList);

        return {
            leftDrawerOpen,
            miniState,
            expanded,
            visible,
            menuState,
            pagePressed,
            businessState,
            selectBusiness,
            closeMenu,
            $q
        };
    }
});
</script>
